<?php

/**
 * @file
 * Node common functionalities
 */
 
function call_deploy_services_url($options) {
  $config = \Drupal::config('dpservices.settings');
  $client = \Drupal::httpClient();
  $url = $config->get('dp_request_url') . DP_REQUEST_URL_CONTENT;
  $method = 'POST';
  try {
    $response = $client->request($method, $url, $options);
    $code = $response->getStatusCode();
	$body = '';
    if ($code == 200) {
      $body = $response->getBody()->getContents();
       $message = 'Deployment for content or block submitted successfully.';
       \Drupal::logger('dpservices')->notice($message);
    }
  }
  catch (RequestException $e) {
     $message = 'There are some issues on deploying content or block.';
     \Drupal::logger('dpservices')->notice($message);
  }
  return $body;
}

function DpservicesNodeIndexFileType($arr_node , $key , $id) {
  foreach($arr_node[$id][$key] as $arr_key=> $value) {	  
    $fid = $value['target_id'];
    $file = \Drupal\file\Entity\File::load($fid);
    $path = $file->getFileUri();
    $image_path = file_url_transform_relative(file_create_url($path));
    $arr_node[$id][$key][$arr_key]['path'] = $path;
    $arr_node[$id][$key][$arr_key]['image_path'] = $image_path;   
  }
  return $arr_node;
}
function GetContentTypeName($bundle , $entity_type_id) {
    foreach (\Drupal::entityManager()->getFieldDefinitions($entity_type_id, $bundle) as $field_name => $field_definition) {
      if (!empty($field_definition->getTargetBundle())) {
        $bundleFields[$entity_type_id][$field_name]['type'] = $field_definition->getType();
        $bundleFields[$entity_type_id][$field_name]['label'] = $field_definition->getLabel();
      }
    }
	return $bundleFields;
}
