<?php
/**
 * @file
 * Contains \Drupal\test_api\Controller\TestAPIController.
 */

namespace Drupal\dpservices\Controller;

use Drupal\Core\Controller\ControllerBase;

use Drupal\Core\Url;



/**
 * Controller routines for deploy routes.
 */
class DeployStatusController extends ControllerBase {

  public function deploy_status() {
    $query = \Drupal::database()->select('dpservices' , 'n');
    $query->fields('n' , array('id' , 'entity_id' , 'type' , 'deploy_date' , 'status'));
	$query->orderBy('deploy_date' , 'DESC');
    $pager = $query->extend('Drupal\Core\Database\Query\PagerSelectExtender')->limit(10);
    $results = $pager->execute()->fetchAll();
    $header = [
     'title' => t('Title'),  
     'type' => t('type'),
     'c_b_type' => t('Content/Block'),
     'status' => t('Status'),
	 'deploy_date' => t('Deploy Date'),
	 'update' => t('Update'),
	 'delete' => t('Delete'),
    ];
	$output = array();	
    foreach ($results AS $value) {
      //$node = \Drupal\node\Entity\Node::load($value->nid);
	  if($value->type == 'node') {		  
	    $node_storage = \Drupal::entityTypeManager()->getStorage('node');
        $node = $node_storage->load($value->entity_id);		
		$title = $node->get('title')->getvalue();
	    $title = $title[0]['value'];
		$type = $node->get('type')->getvalue();
        $type = $type[0]['target_id'];		
	  }
	  else {
        $block_storage = \Drupal::entityTypeManager()->getStorage('block_content');
        $block = $block_storage->load($value->entity_id);
		$title = $block->get('info')->getvalue();
		$title = $title[0]['value'];
		$type = $block->get('type')->getvalue();
		$type = $type[0]['target_id'];	
	  }
	  $status = t('Pending');
	  if($value->status == 1) {
	    $status = t('Completed');
	  }
	  $delete = '-';
	  $update = '-';
	  if($value->status == 0) {
	    $delete = Url::fromUserInput('/admin/dpservices/deploy/delete/' . $value->id);
	    $update = Url::fromUserInput('/admin/dpservices/deploy/update/' . $value->id);
		$update = \Drupal::l('Update', $update);
		$delete = \Drupal::l('Delete', $delete);		
	  }
      $rows[] = array('data' => array(
        'title' => $title,
        'type' => $value->type,
		'c_b_type' => $type,
		'status' => $status,
		'deploy_date' =>  date("Y-m-d H:i:s" , $value->deploy_date),
		$update,
		$delete,
      ));	  
	  
    }
	 $build = array(
      '#markup' => '<h5>' . t('Deployment status') . ':</h5>',
    );
	// Generate the table.
    $build['config_table'] = array(
      '#theme' => 'table',
      '#header' => $header,
      '#rows' => $rows,
    );
 
    // Finally add the pager.
    $build['pager'] = array(
      '#type' => 'pager'
    );
 
    return $build;
  }
   
}
