<?php
/**
 * @file
 * Contains \Drupal\test_api\Controller\TestAPIController.
 */

namespace Drupal\dpservices\Controller;

use Drupal\Core\Controller\ControllerBase;


use Drupal\Core\Database\Database;
use Drupal\Core\TypedData\Exception\MissingDataException;
use Drupal\node\Entity\Node;
use Drupal\Core\Entity\Query\QueryFactory;
use Drupal\Core\Entity\Query;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Field\BaseFieldDefinition;
use Drupal\file\Entity\File;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\JsonResponse;
use Drupal\dpservices\File\DpservicesCopyFile;
use Drupal\dpservices\Entity\DpservicesCreateEntity;
use Drupal\dpservices\Rest\DpservicesResponse;
use Drupal\dpservices\Index\DpservicesGenerateNodeIndex;
use Drupal\dpservices\Entity\DpservicesCheckNodeExists;
use Drupal\field_collection\Entity\FieldCollectionItem;
use Drupal\dpservices\Entity\DpservicesCreateFieldCollection;
use Drupal\dpservices\Logs\DpservicesLogError;
use Drupal\dpservices\Entity\DpservicesCheckBlockExists;

module_load_include('inc', 'dpservices' , 'dpservices.config.inc');

/**
 * Controller routines for deploy routes.
 */
class ResponseAPIController extends ControllerBase {

  /**
   * Callback for 'dpservices/deploy/content.json' API method.
   */
  public $arr_fcollection;
  public $nid , $arr_nid , $node_type , $bid , $arr_bid , $block_type;
   
  public function deploy_content( Request $request ) {   
	// This condition checks the `Content-type` and makes sure to 
    // decode JSON string from the request body into array.
    if ( 0 === strpos( $request->headers->get( 'Content-Type' ), 'application/json' ) ) {
      $data = json_decode( $request->getContent(), TRUE );
      $request->request->replace( is_array( $data ) ? $data : [] );
    }	
	$arr_node = [];
	$arr_block = [];
	//$arr_fcollection = [];	
	if(isset($data['node'])) {	
	  foreach($data['node'] as $k => $result) {
	    $this->nid = $result['nid'][0]['value'];
	    $this->arr_nid[] = $this->nid;
	    $this->node_type = $result['type'][0]['target_id'];
	    $ids = DpservicesCheckNodeExists::CheckNodeExists($this->nid);
		$arr_node = array();
        if (count($ids) === 0)	{
          foreach($result as $key1=>$value1) {
            $res = strpos($key1 , 'field_');
	        $field_type = '';
            if($res !== false) {
              $db_flag = DpservicesCheckNodeExists::CheckNodeFieldExists($key1 , $this->node_type);		  
              if(empty($db_flag)) {
			    DpservicesLogError::LogsNodeFieldExists($key1 , $this->node_type);
			    continue;
			  }				
	          $field_config = \Drupal\field\Entity\FieldStorageConfig::loadByName('node', $key1);
              $field_type = $field_config->get('type');
            }	
	        if(in_array($field_type , DP_FIELD_FILE_TYPE)) {
	          $arr_node = DpservicesCopyFile::deploy_file($value1 , $key1 , $arr_node);	      		  
	        }
	        if(!in_array($field_type , DP_FIELD_COMMON_INDEX)) {
	          $arr_node = DpservicesGenerateNodeIndex::GenerateNodeIndex($value1 , $key1 , $arr_node);	      
	        }
            if($field_type == 'field_collection') {			 
	          $this->arr_fcollection[$key1] = $value1;			
		    }
            if($field_type == 'entity_reference') {
	          $arr_node = DpservicesGenerateNodeIndex::GenerateNodeReferenceIndex($value1 , $key1 , $arr_node);	      
	        }		  
	      }
	      DpservicesCreateEntity::Create($arr_node);
		  $node_obj = Node::load($this->nid);
		  if(isset($this->arr_fcollection) && count($this->arr_fcollection) > 0) {
		    $arr_fcollection = (array) $this->arr_fcollection;
            DpservicesCreateFieldCollection::Create($arr_fcollection , $node_obj);            			
		  }
	    }
	    // Update Node
        else {
	      $node_obj = Node::load($this->nid);
		  $arr_index = [];	
		  foreach($result as $key1=>$value1) {
		    $res = strpos($key1 , 'field_');
	        $field_type = '';
            if($res !== false) {
			  $db_flag = DpservicesCheckNodeExists::CheckNodeFieldExists($key1 , $this->node_type);	
              if(empty($db_flag)) {
			    DpservicesLogError::LogsNodeFieldExists($key1 , $this->node_type);
			    continue;
			  }
	          $field_config = \Drupal\field\Entity\FieldStorageConfig::loadByName('node', $key1);
              $field_type = $field_config->get('type');
            }
		    if($field_type == 'entity_reference') {
		      $node_obj->set($key1 , $value1);
		    }
            foreach($value1 as $key2=>$value2) {
		      if(!in_array($field_type , DP_FIELD_FILE_TYPE)) {				
			    $index = 'value';
			    if($key1 == 'type') {
			      $index = 'target_id';
			    }
			    if(isset($value2[$index])) {
			      $node_obj->set($key1 , $value2[$index]);
			    }			  
			    //$node_obj->save();
			  }
              if(in_array($field_type , DP_FIELD_FILE_TYPE)) {	         
                //$node_obj->set($key1 , array());              		  
                $node_obj_arr = DpservicesCopyFile::deploy_file_single($value2 , $key1 , $key2 , $arr_index , $node_obj);
                //$node_obj->set($key1 , $arr_index[$key1]);
			    //$node_obj->save();
                $node_obj = $node_obj_arr['node'];
                $arr_index = $node_obj_arr['array'];	  
              }
              if($field_type == 'field_collection') {
			    $node_obj = DpservicesCreateFieldCollection::Update($value1 , $node_obj , $key1);
                $node_obj->save();			  
		      }            			
		    }
            if(in_array($field_type , DP_FIELD_FILE_TYPE)) {
			  if(isset($arr_index[$key1])) {
                $node_obj->set($key1 , $arr_index[$key1]);
			    $node_obj->save();
			  }
		    }			  
	      }
          $node_obj->save();
	    }
	  }
	}
    if(isset($data['block'])) {	
	  foreach($data['block'] as $k => $result) {
	    $this->bid = $result['id'][0]['value'];
	    $this->arr_bid[] = $this->bid;
	    $this->block_type = $result['type'][0]['target_id'];
	    $ids = DpservicesCheckBlockExists::CheckBlockExists($this->bid);		
        if (count($ids) === 0)	{
          $blockEntityManager = \Drupal::service('entity.manager')->getStorage('block_content');         		   
          foreach($result as $key1=>$value1) {			
            $res = strpos($key1 , 'field_');
	        $field_type = '';
            if($res !== false) {
              $db_flag = DpservicesCheckBlockExists::CheckBlockFieldExists($key1 , $this->block_type);		  
              if(empty($db_flag)) {
			    DpservicesLogError::LogsBlockFieldExists($key1 , $this->block_type);
			    continue;
			  }				
	          $field_config = \Drupal\field\Entity\FieldStorageConfig::loadByName('block_content', $key1);
              $field_type = $field_config->get('type');
            }			
	        if(in_array($field_type , DP_FIELD_FILE_TYPE)) {
	          $arr_block = DpservicesCopyFile::deploy_file($value1 , $key1 , $arr_block);	      		  
	        }
	        if(!in_array($field_type , DP_FIELD_COMMON_INDEX)) {
	          $arr_block = DpservicesGenerateNodeIndex::GenerateNodeIndex($value1 , $key1 , $arr_block);	      
	        }
            if($field_type == 'field_collection') {			 
	          $this->arr_fcollection[$key1] = $value1;			
		    }
            if($field_type == 'entity_reference') {
	          $arr_block = DpservicesGenerateNodeIndex::GenerateNodeReferenceIndex($value1 , $key1 , $arr_block);	      
	        }		  
	      }		  
		  $block = $blockEntityManager->create($arr_block);
		  $block->save();	      
		  if(isset($this->arr_fcollection) && count($this->arr_fcollection) > 0) {
		    $arr_fcollection = (array) $this->arr_fcollection;
            DpservicesCreateFieldCollection::Create($arr_fcollection , $block);		
		  }
	    }
	    // Update Block
        else {
	      $block_obj = \Drupal\block_content\Entity\BlockContent::load($this->bid);
		  $arr_index = [];	
		  foreach($result as $key1=>$value1) {
		    $res = strpos($key1 , 'field_');
	        $field_type = '';
            if($res !== false) {
			  $db_flag = DpservicesCheckBlockExists::CheckBlockFieldExists($key1 , $this->block_type);	
              if(empty($db_flag)) {
			    DpservicesLogError::LogsBlockFieldExists($key1 , $this->block_type);
			    continue;
			  }
	          $field_config = \Drupal\field\Entity\FieldStorageConfig::loadByName('block_content', $key1);
              $field_type = $field_config->get('type');
            }
		    if($field_type == 'entity_reference') {
		      $block_obj->set($key1 , $value1);
		    }
            foreach($value1 as $key2=>$value2) {
		      if(!in_array($field_type , DP_FIELD_FILE_TYPE)) {				
			    $index = 'value';
			    if($key1 == 'type') {
			      $index = 'target_id';
			    }
			    if(isset($value2[$index])) {
			      $block_obj->set($key1 , $value2[$index]);
			    }
			  }
              if(in_array($field_type , DP_FIELD_FILE_TYPE)) {
                $block_obj_arr = DpservicesCopyFile::deploy_file_single($value2 , $key1 , $key2 , $arr_index , $block_obj);                
                $block_obj = $block_obj_arr['node'];
                $arr_index = $block_obj_arr['array'];	  
              }
              if($field_type == 'field_collection') {
			    $block_obj = DpservicesCreateFieldCollection::Update($value1 , $block_obj , $key1);
                $block_obj->save();			  
		      }            			
		    }
            if(in_array($field_type , DP_FIELD_FILE_TYPE)) {
			  if(isset($arr_index[$key1])) {
                $block_obj->set($key1 , $arr_index[$key1]);
			    $block_obj->save();
			  }
		    }			  
	      }
          $block_obj->save();
	    }        
	  }
	}
    $res_node['node'] = $this->arr_nid;
    $res_node['block'] = $this->arr_bid;	
	//DpservicesResponse::response($data);	
	$response['data'] = $res_node;
    $response['method'] = 'POST';
    return new JsonResponse( $response );	
  }
}
