<?php
/**
 * @file
 * Contains \Drupal\test_api\Controller\TestAPIController.
 */

namespace Drupal\dpservices\Entity;

use Drupal\field_collection\Entity\FieldCollectionItem;
use Drupal\dpservices\File\DpservicesCopyFile;
use Drupal\dpservices\Entity\DpservicesCheckNodeExists;
use Drupal\dpservices\Logs\DpservicesLogError;

module_load_include('inc', 'dpservices' , 'dpservices.config.inc');

/**
 * Controller routines for deploy routes.
 */
class DpservicesCreateFieldCollection {

  /**
   * Create Field collection
   */
  public static function Create($arr_fcollection , $node_obj) {    			
    foreach($arr_fcollection as $fcollectionkey=>$fcollectionvalue) {		  
      foreach($fcollectionvalue as $fcollection_reskey=>$fcollection_resvalue) {
        $fc = FieldCollectionItem::create(array(
		  "field_name" => $fcollectionkey,
		));
        foreach($fcollection_resvalue as $fcollection_freskey=>$fcollection_fresvalue) {
	      $res = strpos($fcollection_freskey , 'field_');
	      $field_type = '';          
		  if($res !== false) {
            $db_flag = DpservicesCheckNodeExists::CheckNodeFCFieldExists($fcollection_freskey , $fcollectionkey);		  
            if($db_flag == 1) {
			  $field_config = \Drupal\field\Entity\FieldStorageConfig::loadByName('field_collection_item', $fcollection_freskey);              
			  if(isset($field_config)) {
			    $field_type = $field_config->get('type');
			  }                        
			  if(in_array($field_type , DP_FIELD_FILE_TYPE)) {
			    $fc = DpservicesCopyFile::deploy_file_fieldcollection($fcollection_fresvalue , $fcollection_freskey , $node_obj , $fc);
			  }
			  else {
	            $fc->set($fcollection_freskey, $fcollection_fresvalue);				
			  }
			}
            else {
			  DpservicesLogError::LogsNodeFieldExists($fcollection_freskey , $node_obj->getType());
			}
          }		    
        }
        $fc->setHostEntity($node_obj);
        $fc->save();
        $node_obj->save(); 
      }			  			  
    }	
  }
  public static function Update($value1 , $node_obj , $key1) {
	//$node_obj->set('field_mobile_image' , array());
    foreach($value1 as $fcollectionkey => $fcollectionvalue) {
      $fc_id = $node_obj->get($key1)->getValue();			  
      $fc = FieldCollectionItem::load($fc_id[$fcollectionkey]['value']);
	  if(isset($fc)) {
        foreach($fcollectionvalue as $fcollection_reskey => $fcollection_resvalue) {
	      $res = strpos($fcollection_reskey , 'field_');
	      $field_type = '';
          if($fcollection_reskey != 'revision_id') {
		    if($res !== false) {
			  $db_flag = DpservicesCheckNodeExists::CheckNodeFCFieldExists($fcollection_reskey , $key1);		  
              if($db_flag == 1) {
				$field_config = \Drupal\field\Entity\FieldStorageConfig::loadByName('field_collection_item', $fcollection_reskey);
			    if(isset($field_config)) {
			      $field_type = $field_config->get('type');
			    }                        
			    if(in_array($field_type , DP_FIELD_FILE_TYPE)) {				  
			      $fc = DpservicesCopyFile::deploy_file_fieldcollection($fcollection_resvalue , $fcollection_reskey , $node_obj , $fc);
			    }
			    else {
			      $fc->set($fcollection_reskey, $fcollection_resvalue);
			    }			    		    
			  }
              else {
			    DpservicesLogError::LogsNodeFieldExists($fcollection_reskey , $node_obj->getType());	
			  }				  
            }	        					  
          }
        }				
        $fc->save();		
	  }
      else {
	    $arr_fcollection[$key1][] = $fcollectionvalue;        
		DpservicesCreateFieldCollection::Create($arr_fcollection , $node_obj);		
	  }		  
    }
	return $node_obj;
  }	  
}
