<?php

namespace Drupal\dpservices\Form;
use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Form\ConfirmFormBase;
use Drupal\Core\Url;
use Drupal\Core\Render\Element;
/**
 * Class DpservicesDeleteForm.
 *
 * @package Drupal\dpservices\Form
 */
class DpservicesDeleteForm extends ConfirmFormBase {
	
  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'dpservices_delete_form';
  }
  
  public $id;
  
  public function getQuestion() { 
    return t('Do you want to delete?');
  }
  
  public function getCancelUrl() {
   return new Url('dpservices.deploy_status');
  }
  
  public function getDescription() {
   return t('Selected content will be deleted.');
  }
  
  /**
   * {@inheritdoc}
   */
   
  public function getConfirmText() {
    return t('Delete');
  }

  /**
   * {@inheritdoc}
   */
   
  public function getCancelText() {
    return t('Cancel');
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state, $id = NULL) {
    $this->id = $id;
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent::validateForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {	  
    $query = \Drupal::database();
    $query->delete('dpservices')
      ->condition('id' , $this->id)
      ->execute();
    drupal_set_message('Succesfully deleted.');
    $form_state->setRedirect('dpservices.deploy_status');
  }
}
